'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class Bars3Cal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        Me.PictureBox2 = New System.Windows.Forms.PictureBox
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(160, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(160, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "構造解析計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 184)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(144, 24)
        Me.PictureBox1.TabIndex = 6
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 139)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(240, 24)
        Me.PictureBox2.TabIndex = 7
        Me.PictureBox2.TabStop = False
        '
        'Bars3Cal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Bars3Cal3"
        Me.Text = "Bars3Cal3"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim SwK As IO.StreamWriter      '結果出力用

    Dim NumEff As Integer           'FEM行列（右上三角）のｲﾝﾃﾞｯｸｽ数

    Dim Fw1, Fw2 As Single          '進行表示の水平枠位置
    Dim Crate As Single             '混合要素におけるﾗｰﾒﾝ要素追加微小比

    Dim Idiag() As Integer          '元のFEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim KEfmax() As Integer         '変位・軸力等最大の要素番号
    Dim KEfmin() As Integer         '変位・軸力等最小の要素番号
    Dim KPfmax() As Integer         '変位・軸力等最大の節点番号
    Dim KPfmin() As Integer         '変位・軸力等最小の節点番号
    Dim Lr() As Integer             '元ﾃﾞｰﾀ節点の第1変数の全体ﾏﾄﾘｯｸｽ番号
    Dim NvarP() As Integer          '各節点順の変数の数

    Dim BarForce(,) As Double       '部材の軸力
    Dim BarYShear(,) As Double      '部材Y軸方向の剪断力
    Dim BarZShear(,) As Double      '部材Z軸方向の剪断力
    Dim BarYMoment(,) As Double     '部材Y軸のﾓｰﾒﾝﾄ
    Dim BarZMoment(,) As Double     '部材Z軸のﾓｰﾒﾝﾄ
    Dim CosXBar(,) As Double        '部材断面X軸の全体X,Y,Z軸に対する方向余弦
    Dim CosZBar(,) As Double        '部材断面Z軸の全体X,Y,Z軸に対する方向余弦
    Dim EForce(), Efb() As Double   '要素の軸力等の配列
    Dim Ek(,), Ekb(,) As Double     '要素計算の２次配列
    Dim Eu() As Double              '節点変位
    Dim Fdirect(,) As Double        '拘束節点の荷重
    Dim RlenBar() As Double         '部材長さ
    Dim Tf() As Double              'FEM計算の右辺ベクトル
    Dim Tfx() As Double             '初期変位
    Dim Tfxx() As Double            '前回の初期変位
    Dim Tk() As Double              'FEM行列の1次元保存配列
    Dim Trans(,) As Double          '座標変換ﾏﾄﾘｯｸｽ
    Dim Zfmax() As Single           '変位・軸力等の最大値
    Dim Zfmin() As Single           '変位・軸力等の最小値

    Private Sub BandWidth2(ByRef mb As Integer, ByVal kcbuf() As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'kcbuf()･･･元の節点の変数順序
        Dim ib, ie, j, k, k1, k2, mx As Integer

        mx = 0
        For ie = 1 To Nelem
            ib = NNelem(ie, 1)
            j = NNelem(ie, 2)
            k = Math.Abs(kcbuf(ib) - kcbuf(j))
            If k > mx Then
                mx = k
            End If
        Next ie
        If Nspring > 0 Then
            For j = 1 To Nspring
                k1 = KPspring(j, 1)
                k2 = KPspring(j, 2)
                If k2 > 0 Then
                    k = Math.Abs(kcbuf(k1) - kcbuf(k2))
                    If k > mx Then mx = k
                End If
            Next j
        End If
        mb = Ndim * (mx + 1)

    End Sub

    Private Sub BandWidth3(ByRef mb As Integer, ByVal kcbuf() As Integer, _
        ByVal nvarb() As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算3
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'kcbuf()･･･元の節点の変数順序
        'nvarb()･･･各節点順の変数の数
        Dim i, ie, j, k, j1, j2, jb, jj, k1, k2, mx As Integer

        mx = 0
        For ie = 1 To Nelem
            i = NNelem(ie, 1)
            j = NNelem(ie, 2)
            j1 = kcbuf(i)
            j2 = kcbuf(j)
            If j1 > j2 Then
                jb = j1
                j1 = j2
                j2 = jb
            End If
            k = 0
            For jj = j1 To j2
                k = k + nvarb(jj)
            Next jj
            If k > mx Then
                mx = k
            End If
        Next ie
        If Nspring > 0 Then
            For j = 1 To Nspring
                k1 = KPspring(j, 1)
                k2 = KPspring(j, 2)
                If k2 > 0 Then
                    j1 = kcbuf(k1)
                    j2 = kcbuf(k2)
                    If j1 > j2 Then
                        jb = j1
                        j1 = j2
                        j2 = jb
                    End If
                    k = 0
                    For jj = j1 To j2
                        k = k + nvarb(jj)
                    Next jj
                    If k > mx Then
                        mx = k
                    End If
                End If
            Next j
        End If

        mb = mx

    End Sub

    Private Sub CoeffMatrix(ByVal istage As Integer, ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'istage･･･応力計算の有無（0:なし、1:有り）
        'ie･･･要素番号
        Dim ib, j, k, kp As Integer
        Dim area, c1, c2, c3, c4, c5, c6, c7, c8, csb, e, g As Double
        Dim riy, riz, rlen, rlen2, rlen3, rnyu, s, ud As Double

        kp = NumMat(ie)
        e = DataMat(kp, 1)
        rnyu = DataMat(kp, 2)
        ud = DataMat(kp, 3)
        area = DataMat(kp, 4)
        riy = DataMat(kp, 5)
        riz = DataMat(kp, 6)
        csb = DataMat(kp, 7)
        g = e / (2 * (1 + rnyu))

        rlen = RlenBar(ie)
        rlen2 = rlen * rlen
        rlen3 = rlen * rlen2
        c1 = e * area / rlen
        c2 = 12 * e * riz / rlen3
        c3 = 6 * e * riz / rlen2
        c4 = 12 * e * riy / rlen3
        c5 = 6 * e * riy / rlen2
        c6 = g * csb / rlen
        c7 = 4 * e * riy / rlen
        c8 = 4 * e * riz / rlen

        Select Case Ntype
            Case 1
                Ek(1, 1) = c1 : Ek(1, 4) = -c1
                Ek(4, 1) = -c1 : Ek(4, 4) = c1
            Case 2
                Ek(1, 1) = c1 : Ek(1, 7) = -c1 : Ek(7, 1) = -c1
                Ek(2, 2) = c2 : Ek(2, 6) = c3 : Ek(6, 2) = c3
                Ek(2, 8) = -c2 : Ek(8, 2) = -c2 : Ek(2, 12) = c3 : Ek(12, 2) = c3
                Ek(3, 3) = c4 : Ek(3, 5) = -c5 : Ek(5, 3) = -c5
                Ek(3, 9) = -c4 : Ek(9, 3) = -c4 : Ek(3, 11) = -c5 : Ek(11, 3) = -c5
                Ek(4, 4) = c6 : Ek(4, 10) = -c6 : Ek(10, 4) = -c6
                Ek(5, 5) = c7 : Ek(5, 9) = c5 : Ek(9, 5) = c5
                Ek(5, 11) = 0.5 * c7 : Ek(11, 5) = 0.5 * c7
                Ek(6, 6) = c8 : Ek(6, 8) = -c3 : Ek(8, 6) = -c3
                Ek(6, 12) = 0.5 * c8 : Ek(12, 6) = 0.5 * c8
                Ek(7, 7) = c1
                Ek(8, 8) = c2 : Ek(8, 12) = -c3 : Ek(12, 8) = -c3
                Ek(9, 9) = c4 : Ek(9, 11) = c5 : Ek(11, 9) = c5
                Ek(10, 10) = c6 : Ek(11, 11) = c7 : Ek(12, 12) = c8
        End Select

        For ib = 1 To Nvar
            For j = 1 To Nvar
                s = 0
                For k = 1 To Nvar
                    s = s + Ek(ib, k) * Trans(k, j)
                Next k
                Ekb(ib, j) = s
            Next j
        Next ib

        If istage = 0 Then
            For ib = 1 To Nvar
                For j = 1 To Nvar
                    s = 0
                    For k = 1 To Nvar
                        s = s + Trans(k, ib) * Ekb(k, j)
                    Next k
                    Ek(ib, j) = s
                Next j
            Next ib
        End If

    End Sub

    Private Sub CoeffMatrix2(ByVal istage As Integer, ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'istage･･･応力計算の有無（0:なし、1:有り）
        'ie･･･要素番号
        Dim ib, j, k, kc, kp As Integer
        Dim cb As Single
        Dim area, c1, c2, c3, c4, c5, c6, c7, c8, csb, e, g As Double
        Dim riy, riz, rlen, rlen2, rlen3, rnyu, s, ud As Double

        cb = 1.0 - Crate
        kc = KindElem(ie)
        kp = NumMat(ie)
        e = DataMat(kp, 1)
        rnyu = DataMat(kp, 2)
        ud = DataMat(kp, 3)
        area = DataMat(kp, 4)
        riy = DataMat(kp, 5)
        riz = DataMat(kp, 6)
        csb = DataMat(kp, 7)
        g = e / (2 * (1 + rnyu))

        rlen = RlenBar(ie)
        rlen2 = rlen * rlen
        rlen3 = rlen * rlen2
        c1 = e * area / rlen
        c6 = g * csb / rlen
        If kc = 2 Then
            c2 = 12 * e * riz / rlen3
            c3 = 6 * e * riz / rlen2
            c4 = 12 * e * riy / rlen3
            c5 = 6 * e * riy / rlen2
            c7 = 4 * e * riy / rlen
            c8 = 4 * e * riz / rlen
        Else
            c2 = 3 * e * riz / rlen3
            c3 = 3 * e * riz / rlen2
            c4 = 3 * e * riy / rlen3
            c5 = 3 * e * riy / rlen2
            c7 = 3 * e * riy / rlen
            c8 = 3 * e * riz / rlen
        End If

        Ek(1, 1) = c1 : Ek(1, 7) = -c1
        Ek(7, 1) = -c1 : Ek(7, 7) = c1
        Select Case kc
            Case 2
                Ek(2, 2) = c2 : Ek(2, 6) = c3 : Ek(6, 2) = c3
                Ek(2, 8) = -c2 : Ek(8, 2) = -c2 : Ek(2, 12) = c3 : Ek(12, 2) = c3
                Ek(3, 3) = c4 : Ek(3, 5) = -c5 : Ek(5, 3) = -c5
                Ek(3, 9) = -c4 : Ek(9, 3) = -c4 : Ek(3, 11) = -c5 : Ek(11, 3) = -c5
                Ek(4, 4) = c6 : Ek(4, 10) = -c6 : Ek(10, 4) = -c6
                Ek(5, 5) = c7 : Ek(5, 9) = c5 : Ek(9, 5) = c5
                Ek(5, 11) = 0.5 * c7 : Ek(11, 5) = 0.5 * c7
                Ek(6, 6) = c8 : Ek(6, 8) = -c3 : Ek(8, 6) = -c3
                Ek(6, 12) = 0.5 * c8 : Ek(12, 6) = 0.5 * c8
                Ek(8, 8) = c2 : Ek(8, 12) = -c3 : Ek(12, 8) = -c3
                Ek(9, 9) = c4 : Ek(9, 11) = c5 : Ek(11, 9) = c5
                Ek(10, 10) = c6 : Ek(11, 11) = c7 : Ek(12, 12) = c8
            Case 3
                Ek(2, 2) = c2 : Ek(2, 8) = -c2 : Ek(2, 12) = c3
                Ek(3, 3) = c4 : Ek(3, 9) = -c4 : Ek(3, 11) = -c5
                Ek(8, 2) = -c2 : Ek(8, 8) = c2 : Ek(8, 12) = -c3
                Ek(9, 3) = -c4 : Ek(9, 9) = c4 : Ek(9, 11) = c5
                Ek(11, 3) = -c5 : Ek(11, 9) = c5 : Ek(11, 11) = c7
                Ek(12, 2) = c3 : Ek(12, 8) = -c3 : Ek(12, 12) = c8
            Case 4
                Ek(2, 2) = c2 : Ek(2, 6) = c3 : Ek(2, 8) = -c2
                Ek(3, 3) = c4 : Ek(3, 5) = -c5 : Ek(3, 9) = -c4
                Ek(5, 3) = -c5 : Ek(5, 5) = c7 : Ek(5, 9) = c5
                Ek(6, 2) = c3 : Ek(6, 6) = c8 : Ek(6, 8) = -c3
                Ek(8, 2) = -c2 : Ek(8, 6) = -c3 : Ek(8, 8) = c2
                Ek(9, 3) = -c4 : Ek(9, 5) = c5 : Ek(9, 9) = c4
        End Select
        If kc > 2 Then
            c2 = 12 * e * riz / rlen3
            c3 = 6 * e * riz / rlen2
            c4 = 12 * e * riy / rlen3
            c5 = 6 * e * riy / rlen2
            c7 = 4 * e * riy / rlen
            c8 = 4 * e * riz / rlen
            Ek(2, 2) = cb * Ek(2, 2) + Crate * c2
            Ek(2, 6) = cb * Ek(2, 6) + Crate * c3
            Ek(6, 2) = Ek(2, 6)
            Ek(2, 8) = cb * Ek(2, 8) - Crate * c2
            Ek(8, 2) = Ek(2, 8)
            Ek(2, 12) = cb * Ek(2, 12) + Crate * c3
            Ek(12, 2) = Ek(2, 12)
            Ek(3, 3) = cb * Ek(3, 3) + Crate * c4
            Ek(3, 5) = cb * Ek(3, 5) - Crate * c5
            Ek(5, 3) = Ek(3, 5)
            Ek(3, 9) = cb * Ek(3, 9) - Crate * c4
            Ek(9, 3) = Ek(3, 9)
            Ek(3, 11) = cb * Ek(3, 11) - Crate * c5
            Ek(11, 3) = Ek(3, 11)
            Ek(4, 4) = Crate * c6
            Ek(4, 10) = - Crate * c6
            Ek(10, 4) = Ek(4, 10)
            Ek(5, 5) = cb * Ek(5, 5) + Crate * c7
            Ek(5, 9) = cb * Ek(5, 9) + Crate * c5
            Ek(9, 5) = Ek(5, 9)
            Ek(5, 11) = Crate * 0.5 * c7
            Ek(11, 5) = Ek(5, 11)
            Ek(6, 6) = cb * Ek(6, 6) + Crate * c8
            Ek(6, 8) = cb * Ek(6, 8) - Crate * c3
            Ek(8, 6) = Ek(6, 8)
            Ek(6, 12) = cb * Ek(6, 12) + Crate * 0.5 * c8
            Ek(12, 6) = Ek(6, 12)
            Ek(8, 8) = cb * Ek(8, 8) + Crate * c2
            Ek(8, 12) = cb * Ek(8, 12) - Crate * c3
            Ek(12, 8) = Ek(8, 12)
            Ek(9, 9) = cb * Ek(9, 9) + Crate * c4
            Ek(9, 11) = cb * Ek(9, 11) + Crate * c5
            Ek(11, 9) = Ek(9, 11)
            Ek(10, 10) = Crate * c6
            Ek(11, 11) = cb * Ek(11, 11) + Crate * c7
            Ek(12, 12) = cb * Ek(12, 12) + Crate * c8
        End If

        For ib = 1 To Nvar
            For j = 1 To Nvar
                s = 0
                For k = 1 To Nvar
                    s = s + Ek(ib, k) * Trans(k, j)
                Next k
                Ekb(ib, j) = s
            Next j
        Next ib

        If istage = 0 Then
            For ib = 1 To Nvar
                For j = 1 To Nvar
                    s = 0
                    For k = 1 To Nvar
                        s = s + Trans(k, ib) * Ekb(k, j)
                    Next k
                    Ek(ib, j) = s
                Next j
            Next ib
        End If

    End Sub

    Private Sub CosCalc()
        '部材の方向余弦の計算
        Dim ie, j, k1, k2 As Integer
        Dim b1 As Double
        Dim buf(3) As Double
        For ie = 1 To Nelem
            k1 = NNelem(ie, 1)
            k2 = NNelem(ie, 2)
            buf(1) = Xdata(k2) - Xdata(k1)
            buf(2) = Ydata(k2) - Ydata(k1)
            buf(3) = Zdata(k2) - Zdata(k1)
            If KindDPL > 0 Then
                If Ntype < 3 Then
                    k1 = Ndim * (Kcomp(k1) - 1)
                    k2 = Ndim * (Kcomp(k2) - 1)
                Else
                    k1 = Lr(k1) - 1
                    k2 = Lr(k2) - 1
                End If
                buf(1) = buf(1) + Tfx(k2 + 1) - Tfx(k1 + 1)
                buf(2) = buf(2) + Tfx(k2 + 2) - Tfx(k1 + 2)
                buf(3) = buf(3) + Tfx(k2 + 3) - Tfx(k1 + 3)
            End If
            b1 = 0
            For j = 1 To 3
                b1 = b1 + buf(j) * buf(j)
            Next j
            RlenBar(ie) = Math.Sqrt(b1)
            For j = 1 To 3
                CosXBar(ie, j) = buf(j) / RlenBar(ie)
            Next j
            b1 = CosXBar(ie, 2) * CosYBar(ie, 3)
            CosZBar(ie, 1) = b1 - CosXBar(ie, 3) * CosYBar(ie, 2)
            b1 = CosXBar(ie, 3) * CosYBar(ie, 1)
            CosZBar(ie, 2) = b1 - CosXBar(ie, 1) * CosYBar(ie, 3)
            b1 = CosXBar(ie, 1) * CosYBar(ie, 2)
            CosZBar(ie, 3) = b1 - CosXBar(ie, 2) * CosYBar(ie, 1)
        Next ie
    End Sub

    Private Sub CosCalc2(ByVal aval1() As Single, ByVal aval2() As Single, _
    ByRef acos() As Single)
        '2点間の方向余弦の計算
        'aval1(),aval2()・・・2点のXYZ座標
        'acos()・・・XYZ座標への方向余弦
        Dim j As Integer
        Dim b1 As Single
        Dim buf(3) As Single

        For j = 1 To 3
            buf(j) = aval2(j) - aval1(j)
        Next j
        b1 = 0
        For j = 1 To 3
            b1 = b1 + buf(j) * buf(j)
        Next j
        b1 = Math.Sqrt(b1)
        For j = 1 To 3
            acos(j) = buf(j) / b1
        Next j

    End Sub

    Private Sub Debug1(ByVal mh As Integer, ByVal nx As Integer)
        '剛性ﾏﾄﾘｯｸｽを出力して停止
        '非0要素のみ出力
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, fxx$
        Dim i, ic, j, j2, ii, kx As Integer
        Dim z1 As Single
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Bars3debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜＜剛性マトリックスデータ＞＞"
        WriteLine(ii, aa$)
        For i = 1 To nx
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            ic = 0
            For j = i To j2
                kx = Idiag(j) - (j - i)
                If kx > Idiag(j - 1) Then
                    z1 = Tk(kx)
                    If z1 <> 0 Then
                        If ic = 0 Then
                            aa$ = Str$(j) + ",  " + Str$(z1)
                        Else
                            aa$ = aa$ + ",    " + Str$(j) + ",  " + Str$(z1)
                        End If
                        If ic = 4 Then
                            PrintLine(ii, aa$)
                            ic = 0
                        Else
                            ic = ic + 1
                        End If
                    End If
                End If
            Next j
            If ic > 0 Then
                PrintLine(ii, aa$)
            End If
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2()
        '右辺ﾍﾞｸﾄﾙを出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Bars3Ddebug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "右辺ベクトル"
        WriteLine(ii, aa$)
        WriteLine(ii, "行番号、右辺値")
        For i = 1 To Nall
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(Tf(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal istage As Integer)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･応力計算の有無（0:なし、1:有り）
        Dim ib, id, ii, j, k, nb As Integer

        j = 0
        For ii = 1 To 2
            ib = NNelem(ie, ii)
            If Ntype < 3 Then
                'k = Ndim * (ib - 1)
                k = Ndim * (Kcomp(ib) - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                    If istage > 0 Then
                        Efb(j) = Tf(k)
                    End If
                Next id
            Else
                k = Lr(ib) - 1
                nb = NvarP(Kcomp(ib))
                For id = 1 To 6
                    j = j + 1
                    k = k + 1
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = k
                    End If
                    If istage > 0 Then
                        If id > nb Then
                            Efb(j) = 0
                        Else
                            Efb(j) = Tf(k)
                        End If
                    End If
                Next id
            End If
        Next ii

        For ib = 1 To Nvar
            For j = 1 To Nvar
                Ek(ib, j) = 0
                Trans(ib, j) = 0
            Next j
        Next ib

        Call TransMatrix(ie)    '座標変換行列の設定
        If Ntype < 3 Then
            Call CoeffMatrix(istage, ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        Else
            Call CoeffMatrix2(istage, ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If


    End Sub

    Private Sub FLoadSet()
        '節点荷重の設定
        Dim i, id, j As Integer
        For i = 1 To Nforce
            'j = Ndim * (KPforce(i) - 1)
            j = Ndim * (Kcomp(KPforce(i)) - 1)
            For id = 1 To Ndim
                j = j + 1
                Tf(j) = Force(i, id)
            Next id
        Next i

    End Sub

    Private Sub FLoadSet2()
        '節点荷重の設定2
        Dim i, id, j As Integer
        For i = 1 To Nforce
            j = Lr(KPforce(i)) - 1
            For id = 1 To NvarP(Kcomp(KPforce(i)))
                j = j + 1
                Tf(j) = Force(i, id)
            Next id
        Next i

    End Sub

    Private Sub FMaxMin(ByRef ic As Integer, ByVal ie As Integer, _
        ByVal ii As Integer, ByVal jj As Integer, ByVal zbuf() As Single)
        '軸力等の最大・最小のﾁｪｯｸ
        'ic･･･初期設定の有無（0:なし、1:有り）
        'ie･･･要素番号
        'ii･･･節点番号
        'jj･･･軸力等配列のﾍﾞｰｽ値(0またはNdim)
        'zbuf()･･･各応力
        Dim k As Integer
        Dim zb As Single

        If ic = 0 Then
            If Ntype = 1 Then
                For k = 0 To 4
                    Select Case k
                        Case 0
                            zb = zbuf(0)
                        Case 4
                            zb = zbuf(1)
                        Case Else
                            zb = EForce(jj + k)
                    End Select
                    If k < 4 Then
                        KEfmax(k) = ie
                        KEfmin(k) = ie
                        KPfmax(k) = ii
                        KPfmin(k) = ii
                        Zfmax(k) = zb
                        Zfmin(k) = zb
                    Else
                        KEfmax(4) = ie
                        KPfmax(4) = ii
                        Zfmax(4) = zb
                    End If
                Next k
            Else
                For k = 0 To 12
                    Select Case k
                        Case 0
                            zb = zbuf(0)
                        Case Is > 6
                            zb = zbuf(k - 6)
                        Case Else
                            zb = EForce(jj + k)
                    End Select
                    If k < 7 Then
                        KEfmax(k) = 1
                        KEfmin(k) = 1
                        KPfmax(k) = ii
                        KPfmin(k) = ii
                        Zfmax(k) = zb
                        Zfmin(k) = zb
                    ElseIf k < 11 Then
                        Select Case k
                            Case 7
                                KEfmax(7) = 1
                                KPfmax(7) = ii
                                Zfmax(7) = zb
                            Case 8
                                KEfmin(7) = 1
                                KPfmin(7) = ii
                                Zfmin(7) = zb
                            Case 9
                                KEfmax(8) = 1
                                KPfmax(8) = ii
                                Zfmax(8) = zb
                            Case 10
                                KEfmin(8) = 1
                                KPfmin(8) = ii
                                Zfmin(8) = zb
                        End Select
                    Else
                        KEfmax(k - 2) = 1
                        KPfmax(k - 2) = ii
                        Zfmax(k - 2) = zb
                    End If
                Next k
            End If
            ic = 1
        Else
            If Ntype = 1 Then
                For k = 0 To 4
                    Select Case k
                        Case 0
                            zb = zbuf(0)
                        Case 4
                            zb = zbuf(1)
                        Case Else
                            zb = EForce(jj + k)
                    End Select
                    If k < 4 Then
                        If zb < Zfmin(k) Then
                            KEfmin(k) = ie
                            KPfmin(k) = ii
                            Zfmin(k) = zb
                        ElseIf zb > Zfmax(k) Then
                            KEfmax(k) = ie
                            KPfmax(k) = ii
                            Zfmax(k) = zb
                        End If
                    Else
                        If zb > Zfmax(4) Then
                            KEfmax(4) = ie
                            KPfmax(4) = ii
                            Zfmax(4) = zb
                        End If
                    End If
                Next k
            Else
                For k = 0 To 12
                    Select Case k
                        Case 0
                            zb = zbuf(0)
                        Case Is > 6
                            zb = zbuf(k - 6)
                        Case Else
                            zb = EForce(jj + k)
                    End Select
                    If k < 7 Then
                        If zb < Zfmin(k) Then
                            KEfmin(k) = ie
                            KPfmin(k) = ii
                            Zfmin(k) = zb
                        ElseIf zb > Zfmax(k) Then
                            KEfmax(k) = ie
                            KPfmax(k) = ii
                            Zfmax(k) = zb
                        End If
                    ElseIf k < 11 Then
                        Select Case k
                            Case 7
                                If zb > Zfmax(7) Then
                                    KEfmax(7) = ie
                                    KPfmax(7) = ii
                                    Zfmax(7) = zb
                                End If
                            Case 8
                                If zb < Zfmin(7) Then
                                    KEfmin(7) = ie
                                    KPfmin(7) = ii
                                    Zfmin(7) = zb
                                End If
                            Case 9
                                If zb > Zfmax(8) Then
                                    KEfmax(8) = ie
                                    KPfmax(8) = ii
                                    Zfmax(8) = zb
                                End If
                            Case 10
                                If zb < Zfmin(8) Then
                                    KEfmin(8) = ie
                                    KPfmin(8) = ii
                                    Zfmin(8) = zb
                                End If
                        End Select
                    Else
                        If zb > Zfmax(k - 2) Then
                            KEfmax(k - 2) = ie
                            KPfmax(k - 2) = ii
                            Zfmax(k - 2) = zb
                        End If
                    End If
                Next k
            End If
        End If

    End Sub

    Private Sub ForceCalc()
        '軸力等の計算
        Dim ib, ic, icount, ie, ii, istage, j, jj, k, k2, kb, kflag, nb As Integer
        Dim area, b1, b2, b3, b4, bb, s As Double
        Dim zbuf(6) As Single
        Dim buf(6) As Double
        ReDim KEfmax(10), KEfmin(10), KPfmax(10), KPfmin(10)
        ReDim Zfmax(10), Zfmin(10)

        Application.DoEvents()
        icount = 0
        istage = 1
        ic = 0
        If Ntype = 1 Then
            nb = 6
            k2 = 3
        Else
            nb = 12
            k2 = 6
        End If
        For ie = 1 To Nelem
            Call ElemMatrix(ie, istage)    '要素ﾏﾄﾘｯｸｽの計算
            For ib = 1 To nb
                s = 0
                For j = 1 To nb
                    s = s + Ekb(ib, j) * Efb(j)
                Next j
                EForce(ib) = s
            Next ib
            kb = NumMat(ie)
            area = DataMat(kb, 4)

            For j = 1 To 2
                ii = NNelem(ie, j)
                jj = Ndim * (j - 1)
                For k = 1 To k2
                    buf(k) = EForce(jj + k)
                Next k
                If j = 1 Then
                    buf(1) = -buf(1)
                End If
                EForce(jj + 1) = buf(1) + BarForce(ie, j)
                EForce(jj + 2) = buf(2) + BarYShear(ie, j)
                EForce(jj + 3) = buf(3) + BarZShear(ie, j)
                zbuf(0) = EForce(jj + 1) / area
                kflag = 0
                Select Case Ntype
                    Case 2
                        kflag = 1
                    Case 3
                        If KindElem(ie) > 1 Then
                            kflag = 1
                        End If
                End Select
                If kflag = 0 Then
                    If Ntype = 3 Then
                        For k = 1 To 6
                            zbuf(k) = 0
                        Next k
                        zbuf(3) = zbuf(0)
                        zbuf(4) = zbuf(0)
                    End If
                Else
                    EForce(jj + 4) = buf(4)
                    EForce(jj + 5) = buf(5) + BarYMoment(ie, j)
                    EForce(jj + 6) = buf(6) + BarZMoment(ie, j)
                    b1 = -EForce(jj + 5) / DataMat(kb, 8)
                    b2 = EForce(jj + 5) / DataMat(kb, 9)
                    b3 = -EForce(jj + 6) / DataMat(kb, 10)
                    b4 = EForce(jj + 6) / DataMat(kb, 11)
                    zbuf(1) = b1 + b3
                    zbuf(2) = zbuf(1)
                    zbuf(3) = b1 + b4
                    zbuf(4) = b2 + b3
                    zbuf(5) = b2 + b4
                    For k = 3 To 5
                        If zbuf(k) > zbuf(1) Then
                            zbuf(1) = zbuf(k)
                        ElseIf zbuf(k) < zbuf(2) Then
                            zbuf(2) = zbuf(k)
                        End If
                    Next k
                    zbuf(3) = zbuf(1) + zbuf(0)
                    zbuf(4) = zbuf(2) + zbuf(0)
                    zbuf(6) = Math.Abs(EForce(jj + 4)) / DataMat(kb, 14)
                End If
                b1 = Math.Abs(EForce(jj + 2))
                b2 = Math.Abs(EForce(jj + 3))
                b3 = Math.Sqrt(b1 * b1 + b2 * b2)
                bb = b1 + b2
                If bb = 0 Then
                    b4 = 0
                Else
                    b4 = (b1 * DataMat(kb, 12) + b2 * DataMat(kb, 13)) / bb
                End If
                If Ntype = 1 Then
                    zbuf(1) = b4 * b3 / area
                Else
                    zbuf(5) = b4 * b3 / area
                End If
                Call ForceOut(ie, ii, jj, zbuf) '軸力等の出力
                Call FMaxMin(ic, ie, ii, jj, zbuf) '軸力等の最大・最小のﾁｪｯｸ
            Next j
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

    End Sub

    Private Sub ForceCalc2(ByVal mb As Integer)
        '全節点の力等計算
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$
        Dim i, ib, icount, id, ie, ip, istage, j, jb, jj, k, kk, mx, nb As Integer
        Dim b1, s As Double
        Dim buf(Nall) As Double

        For i = 1 To NumEff
            Tk(i) = 0
        Next i

        Application.DoEvents()
        icount = 0
        istage = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie, istage)    '要素ﾏﾄﾘｯｸｽの計算
            Call Store()                   '全体ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        Application.DoEvents()
        icount = 0
        For k = 1 To Nall
            s = 0
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 1 To mx
                jj = k + j - 1
                jb = Idiag(jj) - jj
                kk = jb + k
                If kk > Idiag(jj - 1) Then
                    s = s + Tk(kk) * Tf(jj)
                End If
            Next j
            mx = k - 1
            If mx > mb - 1 Then
                mx = mb - 1
            End If
            If mx > 0 Then
                jb = Idiag(k) - k
                For j = 1 To mx
                    jj = k - j
                    kk = jb + jj
                    If kk > Idiag(k - 1) Then
                        s = s + Tk(kk) * Tf(jj)
                    End If
                Next j
            End If
            buf(k) = s
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k
        For k = 1 To Nall
            Tf(k) = buf(k)
        Next k
        For ib = 1 To Nbound
            If Ntype < 3 Then
                'j = Ndim * (Nrest(ib) - 1)
                j = Ndim * (Kcomp(Nrest(ib)) - 1)
                If Ntype = 1 Then
                    nb = 3
                Else
                    nb = 6
                End If
            Else
                k = Nrest(ib)
                j = Lr(k) - 1
                nb = NvarP(Kcomp(k))
            End If
            For id = 1 To nb
                If Jdirect(ib, id) > 0 Then
                    k = j + id
                    b1 = Tf(k)
                    Tf(k) = Fdirect(ib, id)
                    Fdirect(ib, id) = b1 - Tf(k)
                End If
            Next id
        Next ib
        If Ntype = 1 Then
            aa$ = "＜節点番号，Ｆx、Ｆy、Ｆz＞"
        Else
            aa$ = "＜節点番号，Ｆx、Ｆy、Ｆz、Ｍx、Ｍy、Ｍz＞"
        End If
        SwK.WriteLine("--------------------------------------------------")
        SwK.WriteLine("＊＊ 全節点の荷重出力 ＊＊")
        SwK.WriteLine(aa$)
        Application.DoEvents()
        For ip = 1 To Npoint
            If Ntype < 3 Then
                'jj = Ndim * (ip - 1)
                jj = Ndim * (Kcomp(ip) - 1)
                If Ntype = 1 Then
                    nb = 3
                Else
                    nb = 6
                End If
            Else
                jj = Lr(ip) - 1
                nb = NvarP(Kcomp(ip))
            End If
            Call ForceOut2(ip, jj, nb)  '力等の出力
        Next ip
        SwK.WriteLine("--------------------------------------------------")
        SwK.WriteLine("＊＊ 拘束節点の反力 ＊＊")
        SwK.WriteLine(aa$)
        For ib = 1 To Nbound
            ip = Nrest(ib)
            If Ntype < 3 Then
                'j = Ndim * (ip - 1)
                j = Ndim * (Kcomp(ip) - 1)
                If Ntype = 1 Then
                    nb = 3
                Else
                    nb = 6
                End If
            Else
                j = Lr(ip) - 1
                nb = NvarP(Kcomp(ip))
            End If
            For id = 1 To nb
                k = j + id
                Tf(k) = Fdirect(ib, id)
            Next id
            Call ForceOut2(ip, j, nb)  '力等の出力
        Next ib

    End Sub

    Private Sub ForceOut(ByVal ie As Integer, ByVal ii As Integer, _
    ByVal jj As Integer, ByVal zbuf() As Single)
        '軸力等の出力
        'ie･･･要素番号
        'ii･･･節点番号
        'jj･･･軸力等配列のﾍﾞｰｽ値(0またはNdim)
        'zbuf()･･･各応力
        Dim aa$
        Dim j As Integer
        Dim z1 As Single

        aa$ = Str(ie) + ",  " + Str(ii) + ",  " + Str(zbuf(0))
        For j = 1 To 3
            z1 = EForce(jj + j)
            aa$ = aa$ + ",  " + Str(z1)
        Next j
        Select Case Ntype
            Case 1
                aa$ = aa$ + ",  " + Str(zbuf(1))
            Case Else
                For j = 4 To 6
                    z1 = EForce(jj + j)
                    aa$ = aa$ + ",  " + Str(z1)
                Next j
                For j = 1 To 6
                    If j = 1 Then
                        aa$ = aa$ + ",     " + Str(zbuf(j))
                    Else
                        aa$ = aa$ + ",  " + Str(zbuf(j))
                    End If
                Next j
        End Select
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ForceOut2(ByVal ip As Integer, ByVal jj As Integer, ByVal nb As Integer)
        '力等の出力
        'ip･･･節点番号
        'jj･･･力等配列のﾍﾞｰｽ値
        'nb･･･変位の数
        Dim aa$
        Dim i As Integer
        Dim zb As Single

        aa$ = Str$(ip)
        For i = 1 To nb
            zb = Tf(jj + i)
            aa$ = aa$ + ",  " + Str$(zb)
        Next i
        SwK.WriteLine(aa$)

    End Sub

    Private Sub HLoadSet()
        '分布荷重の設定
        '軸力等は初期内力として処理
        Dim ib, ie, ii, k, kb As Integer
        Dim b1, b2, b3, forceb, rmomentb As Double
        Dim kbuf(2) As Integer
        For ib = 1 To Nsurf
            ie = KEsurf(ib)
            For ii = 1 To 2
                kb = NNelem(ie, ii)
                'kbuf(ii) = Ndim * (kb - 1)
                kbuf(ii) = Ndim * (Kcomp(kb) - 1)
            Next ii

            '垂直分布荷重Ｐnyによる換算荷重の計算
            forceb = 0.5 * PnormYB(ib) * RlenBar(ie)
            b1 = forceb * CosYBar(ie, 1)
            b2 = forceb * CosYBar(ie, 2)
            b3 = forceb * CosYBar(ie, 3)
            For ii = 1 To 2
                k = kbuf(ii)
                Tf(k + 1) = Tf(k + 1) + b1
                Tf(k + 2) = Tf(k + 2) + b2
                Tf(k + 3) = Tf(k + 3) + b3
            Next ii
            BarYShear(ie, 1) = -forceb
            BarYShear(ie, 2) = -forceb
            If Ntype = 2 Then
                rmomentb = forceb * RlenBar(ie) / 6
                b1 = rmomentb * CosZBar(ie, 1)
                b2 = rmomentb * CosZBar(ie, 2)
                b3 = rmomentb * CosZBar(ie, 3)
                For ii = 1 To 2
                    k = kbuf(ii)
                    If ii = 2 Then
                        b1 = -b1
                        b2 = -b2
                        b3 = -b3
                    End If
                    Tf(k + 4) = Tf(k + 4) + b1
                    Tf(k + 5) = Tf(k + 5) + b2
                    Tf(k + 6) = Tf(k + 6) + b3
                Next ii
                BarZMoment(ie, 1) = -rmomentb
                BarZMoment(ie, 2) = rmomentb
            End If

            '垂直分布荷重Ｐnzによる換算荷重の計算
            forceb = 0.5 * PnormZB(ib) * RlenBar(ie)
            b1 = forceb * CosZBar(ie, 1)
            b2 = forceb * CosZBar(ie, 2)
            b3 = forceb * CosZBar(ie, 3)
            For ii = 1 To 2
                k = kbuf(ii)
                Tf(k + 1) = Tf(k + 1) + b1
                Tf(k + 2) = Tf(k + 2) + b2
                Tf(k + 3) = Tf(k + 3) + b3
            Next ii
            BarZShear(ie, 1) = -forceb
            BarZShear(ie, 2) = -forceb
            If Ntype = 2 Then
                rmomentb = -forceb * RlenBar(ie) / 6
                b1 = rmomentb * CosYBar(ie, 1)
                b2 = rmomentb * CosYBar(ie, 2)
                b3 = rmomentb * CosYBar(ie, 3)
                For ii = 1 To 2
                    k = kbuf(ii)
                    If ii = 2 Then
                        b1 = -b1
                        b2 = -b2
                        b3 = -b3
                    End If
                    Tf(k + 4) = Tf(k + 4) + b1
                    Tf(k + 5) = Tf(k + 5) + b2
                    Tf(k + 6) = Tf(k + 6) + b3
                Next ii
                BarYMoment(ie, 1) = -rmomentb
                BarYMoment(ie, 2) = rmomentb
            End If

            '接線分布荷重Ｐtによる換算荷重の計算
            forceb = 0.5 * Ptang(ib) * RlenBar(ie)
            b1 = forceb * CosXBar(ie, 1)
            b2 = forceb * CosXBar(ie, 2)
            b3 = forceb * CosXBar(ie, 3)
            For ii = 1 To 2
                k = kbuf(ii)
                Tf(k + 1) = Tf(k + 1) + b1
                Tf(k + 2) = Tf(k + 2) + b2
                Tf(k + 3) = Tf(k + 3) + b3
            Next ii
            BarForce(ie, 1) = forceb
            BarForce(ie, 2) = -forceb
        Next ib

    End Sub

    Private Sub HLoadSet2()
        '分布荷重の設定（ﾄﾗｽ･ﾗｰﾒﾝ混合）
        '軸力等は初期内力として処理
        Dim ib, ie, ii, k, kb As Integer
        Dim cb As Single
        Dim b1, b2, b3, forceb, rmoment1, rmoment2, rmomentb As Double
        Dim kbuf(2) As Integer
        Dim fnorm(2) As Double

        cb = 1.0 - Crate
        For ib = 1 To Nsurf
            ie = KEsurf(ib)
            For ii = 1 To 2
                kb = NNelem(ie, ii)
                kbuf(ii) = Lr(kb) - 1
            Next ii

            '垂直分布荷重Ｐnyによる換算荷重の計算
            Select Case KindElem(ie)
                Case 3
                    fnorm(1) = 3 * PnormYB(ib) * RlenBar(ie) / 8
                    fnorm(2) = 5 * PnormYB(ib) * RlenBar(ie) / 8
                    rmomentb = PnormYB(ib) * RlenBar(ie) * RlenBar(ie) / 8
                Case 4
                    fnorm(1) = 5 * PnormYB(ib) * RlenBar(ie) / 8
                    fnorm(2) = 3 * PnormYB(ib) * RlenBar(ie) / 8
                    rmomentb = PnormYB(ib) * RlenBar(ie) * RlenBar(ie) / 8
                Case Else
                    fnorm(1) = 0.5 * PnormYB(ib) * RlenBar(ie)
                    fnorm(2) = fnorm(1)
                    rmomentb = fnorm(1) * RlenBar(ie) / 6
            End Select
            If KindElem(ie) = 2 Then
                rmoment1 = rmomentb
                rmoment2 = rmomentb
            ElseIf KindElem(ie) > 2 Then
                b1 = Crate * 0.5 * PnormYB(ib) * RlenBar(ie)
                fnorm(1) = cb * fnorm(1) + b1
                fnorm(2) = cb * fnorm(2) + b1
                If KindElem(ie) = 3 Then
                    rmoment1 = b1 * RlenBar(ie) / 6
                    rmoment2 = cb * rmomentb + rmoment1
                Else
                    rmoment2 = b1 * RlenBar(ie) / 6
                    rmoment1 = cb * rmomentb + rmoment2
                End If
            End If
            For ii = 1 To 2
                k = kbuf(ii)
                Tf(k + 1) = Tf(k + 1) + fnorm(ii) * CosYBar(ie, 1)
                Tf(k + 2) = Tf(k + 2) + fnorm(ii) * CosYBar(ie, 2)
                Tf(k + 3) = Tf(k + 3) + fnorm(ii) * CosYBar(ie, 3)
                If KindElem(ie) > 1 Then
                    If ii = 1 Then
                        Tf(k + 4) = Tf(k + 4) + rmoment1 * CosZBar(ie, 1)
                        Tf(k + 5) = Tf(k + 5) + rmoment1 * CosZBar(ie, 2)
                        Tf(k + 6) = Tf(k + 6) + rmoment1 * CosZBar(ie, 3)
                    Else
                        Tf(k + 4) = Tf(k + 4) - rmoment2 * CosZBar(ie, 1)
                        Tf(k + 5) = Tf(k + 5) - rmoment2 * CosZBar(ie, 2)
                        Tf(k + 6) = Tf(k + 6) - rmoment2 * CosZBar(ie, 3)
                    End If
                End If
            Next ii
            BarYShear(ie, 1) = -fnorm(1)
            BarYShear(ie, 2) = -fnorm(2)
            If KindElem(ie) > 1 Then
                BarZMoment(ie, 1) = -rmoment1
                BarZMoment(ie, 2) = rmoment2
            End If

            '垂直分布荷重Ｐnzによる換算荷重の計算
            Select Case KindElem(ie)
                Case 3
                    fnorm(1) = 3 * PnormZB(ib) * RlenBar(ie) / 8
                    fnorm(2) = 5 * PnormZB(ib) * RlenBar(ie) / 8
                    rmomentb = -PnormZB(ib) * RlenBar(ie) * RlenBar(ie) / 8
                Case 4
                    fnorm(1) = 5 * PnormZB(ib) * RlenBar(ie) / 8
                    fnorm(2) = 3 * PnormZB(ib) * RlenBar(ie) / 8
                    rmomentb = -PnormZB(ib) * RlenBar(ie) * RlenBar(ie) / 8
                Case Else
                    fnorm(1) = 0.5 * PnormZB(ib) * RlenBar(ie)
                    fnorm(2) = fnorm(1)
                    rmomentb = -fnorm(1) * RlenBar(ie) / 6
            End Select
            If KindElem(ie) = 2 Then
                rmoment1 = rmomentb
                rmoment2 = rmomentb
            ElseIf KindElem(ie) > 2 Then
                b1 = Crate * 0.5 * PnormZB(ib) * RlenBar(ie)
                fnorm(1) = cb * fnorm(1) + b1
                fnorm(2) = cb * fnorm(2) + b1
                If KindElem(ie) = 3 Then
                    rmoment1 = -b1 * RlenBar(ie) / 6
                    rmoment2 = cb * rmomentb + rmoment1
                Else
                    rmoment2 = -b1 * RlenBar(ie) / 6
                    rmoment1 = cb * rmomentb + rmoment2
                End If
            End If
            For ii = 1 To 2
                k = kbuf(ii)
                Tf(k + 1) = Tf(k + 1) + fnorm(ii) * CosZBar(ie, 1)
                Tf(k + 2) = Tf(k + 2) + fnorm(ii) * CosZBar(ie, 2)
                Tf(k + 3) = Tf(k + 3) + fnorm(ii) * CosZBar(ie, 3)
                If KindElem(ie) > 1 Then
                    If ii = 1 Then
                        Tf(k + 4) = Tf(k + 4) + rmoment1 * CosYBar(ie, 1)
                        Tf(k + 5) = Tf(k + 5) + rmoment1 * CosYBar(ie, 2)
                        Tf(k + 6) = Tf(k + 6) + rmoment1 * CosYBar(ie, 3)
                    Else
                        Tf(k + 4) = Tf(k + 4) - rmoment2 * CosYBar(ie, 1)
                        Tf(k + 5) = Tf(k + 5) - rmoment2 * CosYBar(ie, 2)
                        Tf(k + 6) = Tf(k + 6) - rmoment2 * CosYBar(ie, 3)
                    End If
                End If
            Next ii
            BarZShear(ie, 1) = -fnorm(1)
            BarZShear(ie, 2) = -fnorm(2)
            If KindElem(ie) > 1 Then
                BarYMoment(ie, 1) = -rmoment1
                BarYMoment(ie, 2) = rmoment2
            End If

            '接線分布荷重Ｐtによる換算荷重の計算
            forceb = 0.5 * Ptang(ib) * RlenBar(ie)
            b1 = forceb * CosXBar(ie, 1)
            b2 = forceb * CosXBar(ie, 2)
            b3 = forceb * CosXBar(ie, 3)
            For ii = 1 To 2
                k = kbuf(ii)
                Tf(k + 1) = Tf(k + 1) + b1
                Tf(k + 2) = Tf(k + 2) + b2
                Tf(k + 3) = Tf(k + 3) + b3
            Next ii
            BarForce(ie, 1) = forceb
            BarForce(ie, 2) = -forceb
        Next ib

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ib, id, j, k, nb As Integer

        If Ntype = 1 Then
            Nvar = 6
        Else
            Nvar = 12
        End If

        If Ntype < 3 Then
            Nall = Ndim * Npoint
        Else
            Nall = 0
            For i = 1 To Npoint
                Nall = Nall + NvarP(i)
            Next i
        End If
        ReDim CosXBar(Nelem, 3), CosZBar(Nelem, 3)
        ReDim RlenBar(Nelem)
        ReDim Ek(Nvar, Nvar), Ekb(Nvar, Nvar), Trans(Nvar, Nvar)
        ReDim EForce(Nvar), Efb(Nvar)
        ReDim NPrefer(Nvar), Eu(Nvar)
        ReDim Tf(Nall)
        ReDim BarForce(Nelem, 2), BarYShear(Nelem, 2), BarZShear(Nelem, 2)
        ReDim BarYMoment(Nelem, 2), BarZMoment(Nelem, 2)
        ReDim Fdirect(Nbound, 6)
        If KindDPL > 0 Then
            ReDim Tfx(Nall)
        End If

        If Ntype = 3 Then
            ReDim Lr(Npoint)
            nb = 0
            For i = 1 To Npoint '計算順節点
                For j = 1 To Npoint '元ﾃﾞｰﾀ節点
                    If Kcomp(j) = i Then
                        Lr(j) = nb + 1
                        nb = nb + NvarP(i)
                        Exit For
                    End If
                Next j
            Next i
        End If

        If KindDPL = 2 Then
            ReDim Tfxx(Nall)
            For ib = 1 To Nbound
                If Ntype < 3 Then
                    j = Ndim * (Kcomp(Nrest(ib)) - 1)
                    If Ntype = 1 Then
                        nb = 3
                    Else
                        nb = 6
                    End If
                Else
                    k = Nrest(ib)
                    j = Lr(k) - 1
                    nb = NvarP(Kcomp(k))
                End If
                For id = 1 To nb
                    If Jdirect(ib, id) > 0 Then
                        k = j + id
                        Tfx(k) = Vdirect(ib, id)
                    End If
                Next id
            Next ib

        End If

    End Sub

    Private Sub InitialSet2(ByVal mb As Integer)
        '初期設定2
        Dim aa$
        Dim i, ib, ic, id, ie, ii, ip, j, j1, jb, k, k1, k2, nb, num, numall As Integer
        Dim nbuf(Npoint) As Integer

        '関連節点数の計算
        numall = 0
        nb = Ndim * (Ndim - 1) / 2
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To 2
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To 2
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            If Nspring > 0 Then
                For j = 1 To Nspring
                    k1 = KPspring(j, 1)
                    k2 = KPspring(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If
            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j
            If jb = 0 Then
                aa$ = "対象列が見当たらないエラーが発生しました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            If Ntype < 3 Then
                num = i - jb + 1
                numall = numall + num * Ndim * Ndim - nb
            Else
                GoTo Skip10
                num = 0
                For j = jb To i
                    num = num + NvarP(j) * NvarP(j)
                    If j = i Then
                        nb = NvarP(j) * (NvarP(j) - 1) / 2
                        num = num - nb
                    End If
                Next j
                numall = numall + num
Skip10:
                num = 0
                For id = 1 To NvarP(i)
                    nb = nb + 1
                    For j = jb To i
                        If j < i Then
                            num = num + NvarP(j)
                        Else
                            num = num + id
                        End If
                    Next j
                Next id
                numall = numall + num
            End If
        Next i
        NumEff = numall

        ReDim Tk(NumEff)
        ReDim Idiag(Nall)

        '保存配列との関連付け
        numall = 0
        nb = 0
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To 2
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To 2
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            If Nspring > 0 Then
                For j = 1 To Nspring
                    k1 = KPspring(j, 1)
                    k2 = KPspring(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If
            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j

            If Ntype < 3 Then
                For id = 1 To Ndim
                    nb = nb + 1
                    For j = jb To i
                        If j = i Then
                            k2 = id
                        Else
                            k2 = Ndim
                        End If
                        For k = 1 To k2
                            numall = numall + 1
                        Next k
                    Next j
                    Idiag(nb) = numall
                Next id
            Else
                For id = 1 To NvarP(i)
                    nb = nb + 1
                    For j = jb To i
                        If j < i Then
                            numall = numall + NvarP(j)
                        Else
                            numall = numall + id
                        End If
                    Next j
                    Idiag(nb) = numall
                Next id
            End If
        Next i

    End Sub

    Private Sub LoadSet()
        '荷重の設定
        If Nforce > 0 Then
            If Ntype < 3 Then
                Call FLoadSet() '節点荷重の設定
            Else
                Call FLoadSet2() '節点荷重の設定2
            End If
        End If

        If Nsurf > 0 Then
            If Ntype < 3 Then
                Call HLoadSet() '分布荷重の設定
            Else
                Call HLoadSet2() '分布荷重の設定2
            End If
        End If

    End Sub

    Private Sub MiniSort2(ByVal kbuf() As Integer, ByRef nsort() As Integer, ByVal work() As Single, _
    ByVal xbuf() As Single, ByVal ybuf() As Single, ByVal zbuf() As Single)
        'ﾐﾆｿｰﾄ2
        '同じ変数値の場合に、第2座標値でソート
        'kind･･･主ｿｰﾄの座標軸番号（1:X軸、2:Y軸）
        'nsort()･･･元の変数番号のｿｰﾄ順番号
        'work()･･･ｿｰﾄ変数値
        'xbuf(),ybuf()･･･節点の座標
        Dim i, j, jb, jx, k, k1, k2, kx, nb, n1, n2, nx As Integer
        Dim b1 As Single
        Dim nsbuf(10), nsort2(10), nsort3(10) As Integer
        Dim work2(10), work3(10) As Single

        i = 1
        Do
            If work(i) = work(i + 1) Then
                b1 = work(i)
                n1 = i
                For j = i + 1 To Npoint
                    If b1 = work(j) Then
                        n2 = j
                    Else
                        Exit For
                    End If
                Next j
                nx = n2 - n1 + 1
                ReDim nsort2(nx), work2(nx)
                jb = 0
                For j = n1 To n2
                    jb = jb + 1
                    nsort2(jb) = jb
                    nb = nsort(j)
                    Select Case kbuf(2)
                        Case 1
                            work2(jb) = xbuf(nb)
                        Case 2
                            work2(jb) = ybuf(nb)
                        Case 3
                            work2(jb) = zbuf(nb)
                    End Select
                Next j
                Call ShellSortStd(nx, nsort2, work2)    'ｼｪｯﾙｿｰﾄ基本

                k = 1
                Do
                    If work2(k) = work2(k + 1) Then
                        b1 = work2(k)
                        k1 = k
                        For j = k + 1 To nx
                            If b1 = work2(j) Then
                                k2 = j
                            Else
                                Exit For
                            End If
                        Next j
                        kx = k2 - k1 + 1
                        ReDim nsort3(kx), work3(kx), nsbuf(kx)
                        jb = 0
                        For j = k1 To k2
                            jb = jb + 1
                            nsbuf(jb) = nsort2(j)
                            nsort3(jb) = jb
                            nb = nsort(n1 + nsort2(j) - 1)
                            Select Case kbuf(3)
                                Case 1
                                    work3(jb) = xbuf(nb)
                                Case 2
                                    work3(jb) = ybuf(nb)
                                Case 3
                                    work3(jb) = zbuf(nb)
                            End Select
                        Next j
                        Call ShellSortStd(kx, nsort3, work3)    'ｼｪｯﾙｿｰﾄ基本
                        For j = 1 To kx
                            jb = k1 + j - 1
                            nsort2(jb) = nsbuf(nsort3(j))
                        Next j
                        k = k2 + 1
                    Else
                        k = k + 1
                    End If
                Loop While k < nx

                For j = 1 To nx
                    jb = n1 + nsort2(j) - 1
                    nsort2(j) = nsort(jb)
                Next j
                For j = 1 To nx
                    jx = n1 + j - 1
                    nsort(jx) = nsort2(j)
                Next j
                i = n2 + 1
            Else
                i = i + 1
            End If
        Loop While i < Npoint

    End Sub

    Private Sub NvarPSet()
        '各節点順の変数の数を設定
        Dim i, j, k As Integer
        For i = 1 To Npoint
            NvarP(Kcomp(i)) = 3
        Next i
        For i = 1 To Nelem
            If KindElem(i) > 1 Then
                For j = 1 To 2
                    k = NNelem(i, j)
                    NvarP(Kcomp(k)) = 6
                Next j
            End If
        Next i

    End Sub

    Private Sub NvarPSet2(ByVal kcbuf() As Integer, ByRef nvarb() As Integer)
        '各節点順の変数の数を設定
        'kcbuf()･･･元の節点の変数順序
        'nvarb()･･･各節点順の数
        Dim i, j, k As Integer

        For i = 1 To Npoint
            nvarb(kcbuf(i)) = 3
        Next i
        For i = 1 To Nelem
            If KindElem(i) > 1 Then
                For j = 1 To 2
                    k = NNelem(i, j)
                    nvarb(kcbuf(k)) = 6
                Next j
            End If
        Next i

    End Sub

    Private Sub PnumImproveNew(ByRef mb As Integer, ByVal xbuf() As Single, _
        ByVal ybuf() As Single, ByVal zbuf() As Single)
        '節点順序の改良
        'mb･･･改良後のﾊﾞﾝﾄﾞ幅
        'xbuf(),ybuf(),zbuf()･･･節点の座標
        Dim i, ib, ic, ie, k, k1, k2, mbb, mbx As Integer
        Dim rlenb As Single
        Dim kbuf(3), kbufb(3), kcbuf(Npoint), nvarb(Npoint) As Integer
        Dim rlbuf(3) As Single
        ReDim Kcomp(Npoint), KRcomp(Npoint), NvarP(Npoint)

        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        If Ntype = 3 Then
            Call NvarPSet2(Kcomp, NvarP)     '各節点順の変数の数を設定
        End If
        If Ntype < 3 Then
            Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算2
        Else
            Call BandWidth3(mbx, Kcomp, NvarP)  'ﾊﾞﾝﾄﾞ幅の計算3
        End If

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie
        Call AxisCheck(1, Nelem, rlenb, xbuf, ybuf, zbuf)     'X、Y、Z軸の最小・最大値のﾁｪｯｸ

        mbb = 0
        For k = 1 To 3
            kbuf(1) = k
            Select Case k
                Case 1
                    k1 = 2
                    k2 = 3
                Case 2
                    k1 = 3
                    k2 = 1
                Case 3
                    k1 = 1
                    k2 = 2
            End Select
            rlbuf(k1) = AxisMax(k1) - AxisMin(k1)
            rlbuf(k2) = AxisMax(k2) - AxisMin(k2)
            If rlbuf(k1) > rlbuf(k2) Then
                kbuf(2) = k1
                kbuf(3) = k2
            Else
                kbuf(2) = k2
                kbuf(3) = k1
            End If

            Call ShellSort2(kbuf, kcbuf, xbuf, ybuf, zbuf)    'ｼｪﾙｿｰﾄ2
            If Ntype = 3 Then
                Call NvarPSet2(kcbuf, nvarb)     '各節点順の変数の数を設定
            End If
            If Ntype < 3 Then
                Call BandWidth2(mb, kcbuf)  'ﾊﾞﾝﾄﾞ幅の計算2
            Else
                Call BandWidth3(mb, kcbuf, nvarb)  'ﾊﾞﾝﾄﾞ幅の計算3
            End If
            ic = 0
            If k = 1 Or mb < mbb Then
                ic = 1
            End If
            If ic > 0 Then
                For i = 1 To 3
                    kbufb(i) = kbuf(i)
                Next i
                mbb = mb
            End If
        Next k

        If mbb < mbx Then
            For i = 1 To 3
                kbuf(i) = kbufb(i)
            Next i
            Call ShellSort2(kbuf, kcbuf, xbuf, ybuf, zbuf)    'ｼｪﾙｿｰﾄ2
            If Ntype = 3 Then
                Call NvarPSet2(kcbuf, nvarb)     '各節点順の変数の数を設定
            End If
            If Ntype < 3 Then
                Call BandWidth2(mb, kcbuf)  'ﾊﾞﾝﾄﾞ幅の計算2
            Else
                Call BandWidth3(mb, kcbuf, nvarb)  'ﾊﾞﾝﾄﾞ幅の計算3
            End If
            For i = 1 To Npoint
                Kcomp(i) = kcbuf(i)
            Next i
            If Ntype = 3 Then
                For i = 1 To Npoint
                    NvarP(i) = nvarb(i)
                Next i
            End If
        Else
            mb = mbx
        End If

        For i = 1 To Npoint
            ib = Kcomp(i)
            KRcomp(ib) = i
        Next i

    End Sub

    Private Sub RelaxCalc(ByRef tfb As Double, ByVal tfx As Double, _
    ByVal tfxx As Double)
        '緩和計算
        'tfb･･･今回値
        'tfx･･･前回値
        'tfxx･･･前々回値
        Dim b1, b3, b4 As Double
        b1 = tfb - tfx
        b3 = Math.Abs(b1)
        b4 = Math.Abs(tfx - tfxx)
        If b3 > b4 Then
            If b4 = 0 Then
                b4 = 0.2 * b3
            End If
            tfb = tfx + b1 * b4 / b3
        End If
        tfb = (tfb + 3 * tfx + tfxx) / 5
        'tfb = (tfb + 2 * tfx + 3 * tfxx) / 6

    End Sub

    Private Sub RelaxCalc2(ByRef tfb As Double, ByVal tfx As Double)
        '繰返し2回目の緩和計算
        'tfb･･･今回値
        'tfx･･･前回値
        Dim b1, b3, b4, c1 As Double

        'c1 = 0.1
        c1 = 0.5
        b1 = tfb - tfx
        b3 = Math.Abs(b1)
        b4 = Math.Abs(tfx)
        If b3 > c1 * b4 Then
            If b4 = 0 Then
                'b4 = 0.2 * b3
                b4 = 0.5 * b3
            End If
            tfb = tfx + b1 * c1 * b4 / b3
            tfb = 0.5 * (tfb + tfx)
        End If

    End Sub

    Private Sub ReqTime(ByVal Crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'Crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / Crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        aa$ = "＜＜部材３次元体の構造解析結果＞＞"
        Select Case Ntype
            Case 1
                aa$ = aa$ + "トラス"
            Case 2
                aa$ = aa$ + "ラーメン"
            Case 3
                aa$ = aa$ + "トラス・ラーメン混合"
        End Select
        SwK.WriteLine(aa$)
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)
        SwK.WriteLine("--------------------------------------------------")

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$

        SwK.WriteLine("＊＊＊ 計算結果 ＊＊＊")
        aa$ = "バンド幅" + "," + Str(mb)
        SwK.WriteLine(aa$)
        aa$ = "保存配列のインデックス数" + "," + Str(NumEff)
        SwK.WriteLine(aa$)
        SwK.WriteLine("--------------------------------------------------")

    End Sub

    Private Sub ResFile3(ByVal iconv As Integer, ByVal nk As Integer, _
    ByVal eps As Single)
        '結果ﾌｧｲﾙへの出力3
        'iconv･･･収束有無（0:非収束、1:収束）
        'nk･･･計算回数
        'eps･･･誤差率
        Dim a3$, a4$, aa$
        Dim ic, ip, j, jmax, k As Integer
        Dim zb As Single
        Dim zbuf(6) As Single
        ReDim KPfmax(6), Zfmax(6)

        If KindDPL > 0 Then
            If KindDPL = 1 Then
                SwK.WriteLine("大変形計算を適用")
            Else
                SwK.WriteLine("後変形計算を適用")
            End If
            If iconv = 0 Then
                aa$ = "非収束計算回数" + "," + Str(nk)
                SwK.WriteLine(aa$)
            Else
                aa$ = "収束計算回数" + "," + Str(nk)
                SwK.WriteLine(aa$)
            End If
            aa$ = "誤差率" + "," + Str(eps)
            SwK.WriteLine(aa$)
            SwK.WriteLine("--------------------------------------------------")
        End If
        SwK.WriteLine("＊＊ 変位等の出力 ＊＊")
        If Ntype = 1 Then
            SwK.WriteLine("＜節点番号，δX、δY、δZ＞")
        Else
            SwK.WriteLine("＜節点番号，δX、δY、δZ、θx、θy、θz＞")
        End If
        If Ntype = 1 Then
            jmax = 3
        Else
            jmax = 6
        End If
        ic = 0
        For ip = 1 To Npoint
            If Ntype < 3 Then
                k = Ndim * (Kcomp(ip) - 1)
            Else
                k = Lr(ip) - 1
                jmax = NvarP(Kcomp(ip))
            End If
            aa$ = Str(ip)
            zb = 0
            For j = 1 To jmax
                zbuf(j) = Tf(k + j)
                If j < 4 Then
                    zb = zb + zbuf(j) * zbuf(j)
                End If
                aa$ = aa$ + ",  " + Str$(zbuf(j))
            Next j
            zbuf(0) = zb
            SwK.WriteLine(aa$)

            If ic = 0 Then
                For j = 0 To jmax
                    KPfmax(j) = 1
                    Zfmax(j) = zbuf(j)
                Next j
                ic = 1
            Else
                For j = 0 To jmax
                    If Math.Abs(zbuf(j)) > Math.Abs(Zfmax(j)) Then
                        KPfmax(j) = ip
                        Zfmax(j) = zbuf(j)
                    End If
                Next j
            End If
        Next ip
        Zfmax(0) = Math.Sqrt(Zfmax(0))
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine("--------------------------------------------------")
        SwK.WriteLine("＜変位の最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜変位の最大値データ＞" + Cr$ + aa$
        aa$ = "変位項目、  最大値、        節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For k = 0 To jmax
            Select Case k
                Case 0
                    aa$ = "全δ"
                Case 1
                    aa$ = "δX"
                Case 2
                    aa$ = "δY"
                Case 3
                    aa$ = "δZ"
                Case 4
                    aa$ = "θx"
                Case 5
                    aa$ = "θy"
                Case 6
                    aa$ = "θz"
            End Select
            If k = 0 Then
                j = 7
            Else
                j = 8
            End If
            aa$ = aa$ + "," + Space(j)
            a3$ = Str(Zfmax(k))
            a4$ = Space(16 - Len(a3$))
            aa$ = aa$ + a3$ + "," + a4$
            aa$ = aa$ + Str(KPfmax(k))
            SwK.WriteLine(aa$)
            If k < 4 Then
                CalcRes$ = CalcRes$ + Cr$ + aa$
            End If
        Next k
        If Ntype = 1 Then
            aa$ = "＜要素No.、節点No.、σf、軸力、ＦyB、ＦzB"
            aa$ = aa$ + "、  τA＞"
        Else
            aa$ = "＜要素No.、節点No.、σf、軸力、ＦyB、ＦzB、ＭxB、ＭyB、ＭzB"
            aa$ = aa$ + "、     σbU、σbL、σAU、σAL、τA、τp＞"
        End If
        SwK.WriteLine("--------------------------------------------------")
        SwK.WriteLine("＊＊ 応力・軸力等の出力 ＊＊")
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim a1$, a3$, a4$, aa$
        Dim i, j, k As Integer

        a1$ = ""
        aa$ = "注）正負の最大、最小。"
        SwK.WriteLine("--------------------------------------------------")
        SwK.WriteLine("＜応力・軸力等の最大・最小値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + "＜応力の最大・最小値データ＞"
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、    変数値、         要素番号、   節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        If Ntype = 1 Then
            For i = 0 To 4
                Select Case i
                    Case 0
                        a1$ = "軸σf "
                        j = 5
                    Case 1
                        a1$ = "軸力 "
                        j = 6
                    Case 2
                        a1$ = "剪断ＦyB "
                        j = 2
                    Case 3
                        a1$ = "剪断ＦzB "
                        j = 2
                    Case 4
                        a1$ = "剪断τA "
                        j = 3
                End Select
                For k = 1 To 2
                    Select Case k
                        Case 1
                            aa$ = a1$ + "max," + Space(j)
                            a3$ = Str(Zfmax(i))
                            a4$ = Space(16 - Len(a3$))
                            aa$ = aa$ + a3$ + "," + a4$
                            a3$ = Str(KEfmax(i))
                            a4$ = Space(12 - Len(a3$))
                            aa$ = aa$ + a3$ + "," + a4$
                            aa$ = aa$ + Str(KPfmax(i))
                            SwK.WriteLine(aa$)
                            If i = 0 Or i > 3 Then
                                CalcRes$ = CalcRes$ + Cr$ + aa$
                            End If
                        Case 2
                            If i < 4 Then
                                aa$ = a1$ + "min," + Space(j)
                                a3$ = Str(Zfmin(i))
                                a4$ = Space(16 - Len(a3$))
                                aa$ = aa$ + a3$ + "," + a4$
                                a3$ = Str(KEfmin(i))
                                a4$ = Space(12 - Len(a3$))
                                aa$ = aa$ + a3$ + "," + a4$
                                aa$ = aa$ + Str(KPfmin(i))
                                SwK.WriteLine(aa$)
                                If i = 0 Then
                                    CalcRes$ = CalcRes$ + Cr$ + aa$
                                End If
                            End If
                    End Select
                Next k
            Next i
        Else
            For i = 0 To 10
                Select Case i
                    Case 0
                        a1$ = "軸σf "
                        j = 5
                    Case 1
                        a1$ = "軸力 "
                        j = 6
                    Case 2
                        a1$ = "剪断ＦyB "
                        j = 2
                    Case 3
                        a1$ = "剪断ＦzB "
                        j = 2
                    Case 4
                        a1$ = "捩りＭxB "
                        j = 2
                    Case 5
                        a1$ = "曲げＭyB "
                        j = 2
                    Case 6
                        a1$ = "曲げＭzB "
                        j = 2
                    Case 7
                        a1$ = "曲げσb "
                        j = 3
                    Case 8
                        a1$ = "合計σA "
                        j = 3
                    Case 9
                        a1$ = "剪断τA "
                        j = 3
                    Case 10
                        a1$ = "捩りτp "
                        j = 3
                End Select
                For k = 1 To 2
                    Select Case k
                        Case 1
                            aa$ = a1$ + "max," + Space(j)
                            a3$ = Str(Zfmax(i))
                            a4$ = Space(16 - Len(a3$))
                            aa$ = aa$ + a3$ + "," + a4$
                            a3$ = Str(KEfmax(i))
                            a4$ = Space(12 - Len(a3$))
                            aa$ = aa$ + a3$ + "," + a4$
                            aa$ = aa$ + Str(KPfmax(i))
                            SwK.WriteLine(aa$)
                            If i = 0 Or i > 6 Then
                                CalcRes$ = CalcRes$ + Cr$ + aa$
                            End If
                        Case 2
                            If i < 9 Then
                                aa$ = a1$ + "min," + Space(j)
                                a3$ = Str(Zfmin(i))
                                a4$ = Space(16 - Len(a3$))
                                aa$ = aa$ + a3$ + "," + a4$
                                a3$ = Str(KEfmin(i))
                                a4$ = Space(12 - Len(a3$))
                                aa$ = aa$ + a3$ + "," + a4$
                                aa$ = aa$ + Str(KPfmin(i))
                                SwK.WriteLine(aa$)
                                If i = 0 Or i > 6 Then
                                    CalcRes$ = CalcRes$ + Cr$ + aa$
                                End If
                            End If
                    End Select
                Next k
            Next i
        End If

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
        ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, k1, ka, mx As Integer

        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it
                k1 = Idiag(k) - j
                If k1 > Idiag(k - 1) Then
                    If ub <> 0 Then
                        Tf(it) = Tf(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next it
        End If
        If k < Nall Then
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 2 To mx
                k1 = Idiag(k + j - 1) - j + 1
                If k1 > Idiag(k + j - 2) Then
                    If ub <> 0 Then
                        it = k + j - 1
                        Tf(it) = Tf(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next j
        End If
        Tk(Idiag(k)) = 1
        Tf(k) = ub

    End Sub

    Private Sub ShellSort2(ByVal kbuf() As Integer, ByRef kcbuf() As Integer, _
    ByVal xbuf() As Single, ByVal ybuf() As Single, ByVal zbuf() As Single)
        'ｼｪﾙｿｰﾄ
        Dim i As Integer
        Dim nsort(Npoint) As Integer
        Dim work(Npoint) As Single

        Select Case kbuf(1)
            Case 1
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Xdata(i)
                Next i
            Case 2
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Ydata(i)
                Next i
            Case 3
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Zdata(i)
                Next i
        End Select

        Call ShellSortStd(Npoint, nsort, work)    'ｼｪｯﾙｿｰﾄ基本

        Call MiniSort2(kbuf, nsort, work, xbuf, ybuf, zbuf)    'ﾐﾆｿｰﾄ

        For i = 1 To Npoint
            kcbuf(nsort(i)) = i
        Next i

    End Sub

    Private Sub ShellSortStd(ByVal nx As Integer, ByRef nsort() As Integer, ByRef work() As Single)
        'ｼｪﾙｿｰﾄ基本
        'nx･･･変数の数
        'nsort()･･ｿｰﾄ順の元変数の番号
        'work()･･･ｿｰﾄ順の変数値
        Dim i, ib, j, m As Integer
        Dim varb As Single

        m = nx
        Do While m > 1
            m = m \ 2
            For j = m + 1 To nx
                varb = work(j)
                ib = nsort(j)
                i = j - m
                Do While work(i) >= varb
                    work(i + m) = work(i)
                    nsort(i + m) = nsort(i)
                    i = i - m
                    If i <= 0 Then
                        Exit Do
                    End If
                Loop
                work(i + m) = varb
                nsort(i + m) = ib
            Next j
        Loop

    End Sub

    Private Sub Solver1()
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL'分解）
        Dim aa$, timn$
        Dim i, ib, icount, ii, ij, ik, j, j1, jb, jj, jk, k, k1, kdiv, kk, ks As Integer
        Dim Crate, dn, fwx, riter, rmesh As Single
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0
        rmesh = 0.8
        dn = Nall / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Dim time1 As Date = Now
        For i = 2 To Nall
            ib = Idiag(i) - i
            j1 = Idiag(i - 1) - ib + 1
            For j = j1 To i
                sum = 0
                jb = Idiag(j) - j
                ks = Idiag(j - 1) - jb + 1
                If ks > j1 Then
                    k1 = ks
                Else
                    k1 = j1
                End If
                ij = ib + j
                If k1 <= j - 1 Then
                    For k = k1 To j - 1
                        ik = ib + k
                        kk = Idiag(k)
                        jk = jb + k
                        sum = sum + Tk(ik) * Tk(kk) * Tk(jk)
                    Next k
                End If
                If j = i Then
                    ii = Idiag(i)
                    Tk(ii) = Tk(ii) - sum
                Else
                    jj = Idiag(j)
                    Tk(ij) = (Tk(ij) - sum) / Tk(jj)
                End If
            Next j
            If KindDPL = 0 Then
                riter = riter - 1
                If riter <= 0 Then
                    rmesh = rmesh - 0.06
                    Crate = 1 - rmesh
                    fwx = rmesh * Fw1 + Crate * Fw2
                    ProgressBar1.Value = 100 * fwx / Fw2
                    kdiv = kdiv + 1
                    riter = dn
                End If
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, ib, j, j1, j2, j3, k, kk As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        For i = 2 To Nall
            sum = 0
            ib = Idiag(i) - i
            j1 = Idiag(i - 1) - ib + 1
            If j1 < i Then
                For j = j1 To i - 1
                    kk = ib + j
                    sum = sum + Tk(kk) * Tf(j)
                Next j
            End If
            Tf(i) = Tf(i) - sum
        Next i
        For i = 1 To Nall
            k = Idiag(i)
            If Tk(k) = 0 Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / Tk(k)
        Next i

        For i = Nall - 1 To 1 Step -1
            j1 = i + 1
            j2 = j1 + mh - 1
            If j2 > Nall Then
                j2 = Nall
            End If
            sum = 0
            For j = j1 To j2
                j3 = Idiag(j - 1) - Idiag(j) + j + 1
                If j3 <= i Then
                    kk = Idiag(j) - j + i
                    sum = sum + Tk(kk) * Tf(j)
                End If
            Next j
            Tf(i) = Tf(i) - sum
        Next i

        gr.Dispose()

    End Sub

    Private Sub SpringSet()
        'バネ支持の設定
        Dim ib, j, jj, k, k1, k2, kb, kk, m As Integer
        Dim b1 As Single
        Dim acos(3), aval1(3), aval2(3), csb(3), fsb(3) As Single
        For ib = 1 To Nspring
            If KPspring(ib, 2) = 0 Then '単独ﾊﾞﾈ
                If Ntype < 3 Then
                    k = Ndim * (Kcomp(KPspring(ib, 1)) - 1)
                Else
                    k = Lr(KPspring(ib, 1)) - 1
                End If
                For j = 1 To 3
                    k = k + 1
                    kk = Idiag(k)
                    Tk(kk) = Tk(kk) - Cspring(ib, j)
                    Tf(k) = Tf(k) + Fspring(ib, j)
                Next j
            Else  '節点間ﾊﾞﾈ
                k1 = KPspring(ib, 1)
                k2 = KPspring(ib, 2)
                aval1(1) = Xdata(k1)
                aval1(2) = Ydata(k1)
                aval1(3) = Zdata(k1)
                aval2(1) = Xdata(k2)
                aval2(2) = Ydata(k2)
                aval2(3) = Zdata(k2)
                Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
                For j = 1 To 3
                    csb(j) = Cspring(ib, 1) * acos(j)
                    fsb(j) = Fspring(ib, 1) * acos(j)
                Next j
                If Ntype < 3 Then
                    k1 = Ndim * (Kcomp(k1) - 1)
                    k2 = Ndim * (Kcomp(k2) - 1)
                Else
                    k1 = Lr(k1) - 1
                    k2 = Lr(k2) - 1
                End If
                For m = 1 To 2  '節点1と2
                    If m = 1 Then
                        k = k1
                        b1 = 1  '右辺への初期ﾊﾞﾈ力の加算符号
                    Else
                        k = k2
                        b1 = -1
                    End If
                    For j = 1 To 3  'XYZ方向
                        k = k + 1
                        kk = Idiag(k)
                        Tk(kk) = Tk(kk) - csb(j) * acos(j)
                        Tf(k) = Tf(k) + b1 * fsb(j)
                        If j < 3 Then
                            For jj = j + 1 To 3
                                kb = k + jj - 1
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) - csb(j) * acos(jj)
                            Next jj
                        End If
                        If m = 1 And k1 < k2 Then   '大きい変数番号の側で記憶
                            For jj = 1 To 3
                                kb = k2 + jj
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                            Next jj
                        ElseIf m = 2 And k2 < k1 Then
                            For jj = 1 To 3
                                kb = k1 + jj
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                            Next jj
                        End If
                    Next j
                Next m
            End If
        Next ib
    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, itb, j, jt, jtb, k As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it <= jt Then
                            itb = it
                            jtb = jt
                        Else
                            itb = jt
                            jtb = it
                        End If
                        k = Idiag(jtb) - jtb + itb
                        Tk(k) = Tk(k) + Ek(i, j)
                    End If
                Next j
            End If
        Next i
    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub TransMatrix(ByVal ie As Integer)
        '座標変換行列の設定
        'ie･･･要素番号
        Dim ib, j As Integer
        Dim b1 As Double
        Dim buf(3, 3) As Double

        For ib = 1 To 3
            For j = 1 To 3
                Select Case ib
                    Case 1
                        b1 = CosXBar(ie, j)
                    Case 2
                        b1 = CosYBar(ie, j)
                    Case 3
                        b1 = CosZBar(ie, j)
                End Select
                buf(ib, j) = b1
            Next j
        Next ib
        For ib = 1 To 3
            For j = 1 To 3
                b1 = buf(ib, j)
                Trans(ib, j) = b1
                Trans(ib + 3, j + 3) = b1
                If Ntype > 1 Then
                    Trans(ib + 6, j + 6) = b1
                    Trans(ib + 9, j + 9) = b1
                End If
            Next j
        Next ib

    End Sub

    Private Sub VCosCalc2()
        '断面ＹB軸の方向余弦計算2（大変形用）
        Dim i, ic, ie, j, k1, k2 As Integer
        Dim alpha, b1, hpai, rlen1, rlenb As Single
        Dim thetax, thetay, thetaz As Single
        Dim buf(3), bufS(3), vec(4) As Single

        hpai = 1.570796
        alpha = Pai / 180
        For ie = 1 To Nelem
            k1 = NNelem(ie, 1)
            k2 = NNelem(ie, 2)
            buf(1) = Xdata(k2) - Xdata(k1)
            buf(2) = Ydata(k2) - Ydata(k1)
            buf(3) = Zdata(k2) - Zdata(k1)
            For j = 1 To 3
                bufS(j) = buf(j)
            Next j
            If Ntype < 3 Then
                k1 = Ndim * (Kcomp(k1) - 1)
                k2 = Ndim * (Kcomp(k2) - 1)
            Else
                k1 = Lr(k1) - 1
                k2 = Lr(k2) - 1
            End If
            buf(1) = buf(1) + Tfx(k2 + 1) - Tfx(k1 + 1)
            buf(2) = buf(2) + Tfx(k2 + 2) - Tfx(k1 + 2)
            buf(3) = buf(3) + Tfx(k2 + 3) - Tfx(k1 + 3)

            thetax = -AngleYBar(ie) * alpha     '第1ｽﾃｯﾌﾟ
            If buf(3) < 0 Then  '要素を上向き方向に変換
                thetax = -thetax
                For j = 1 To 3
                    buf(j) = -buf(j)
                Next j
            End If
            '第2ｽﾃｯﾌﾟ
            ic = 0
            If bufS(3) = 0 Then  '水平の場合
                thetay = 0
            ElseIf bufS(1) = 0 And bufS(2) = 0 Then   '垂直の場合
                thetay = hpai
                ic = 1
                thetaz = 0
            Else
                b1 = 0
                For j = 1 To 3
                    b1 = b1 + buf(j) * buf(j)
                Next j
                rlenb = Math.Sqrt(b1)     '要素長さ
                b1 = 0
                For j = 1 To 2
                    b1 = b1 + buf(j) * buf(j)
                Next j
                rlen1 = Math.Sqrt(b1)     'XY平面への投影長さ
                thetay = -Math.Atan(buf(3) / rlen1)   'X軸上での回転角
            End If
            If ic = 0 Then
                If buf(1) = 0 Then  'X座標が同じ場合
                    If buf(2) > 0 Then
                        thetaz = hpai
                    Else
                        thetaz = -hpai
                    End If
                ElseIf buf(2) = 0 Then  'Y座標が同じ場合
                    If buf(1) > 0 Then
                        thetaz = 0
                    Else
                        thetaz = Pai
                    End If
                Else
                    thetaz = Math.Atan(buf(2) / buf(1))
                    If buf(1) < 0 Then
                        thetaz = thetaz + Pai
                    End If
                End If
            End If
            Call TMatrixCos(thetax, thetay, thetaz)  '方向余弦用変換ﾏﾄﾘｯｸｽの計算
            vec(1) = 0
            vec(2) = 0
            vec(3) = 1  'Z軸ﾍﾞｸﾄﾙに取る
            vec(4) = 1
            For i = 1 To 3
                b1 = 0
                For j = 1 To 4
                    b1 = b1 + TransMat(i, j) * vec(j)
                Next j
                CosYBar(ie, i) = b1
            Next i
        Next ie
    End Sub

    Private Sub WeightLoad()
        '自重荷重の加算
        '軸力等は初期内力として処理
        Dim ie, ii, k, kb, kk, kp, kx As Integer
        Dim area, b1, b2, b3, forceb, pny, pnz, ptload, rmomentb As Double
        Dim ud, weightk, weights As Double
        Dim kbuf(2) As Integer
        kb = 0
        For ie = 1 To Nelem
            kp = NumMat(ie)
            If kp <> kb Then
                kb = kp
                ud = DataMat(kp, 3)
                area = DataMat(kp, 4)
            End If
            If ud > 0 Then
                For ii = 1 To 2
                    kx = NNelem(ie, ii)
                    'kbuf(ii) = Ndim * (kx - 1)
                    kbuf(ii) = Ndim * (Kcomp(kx) - 1)
                Next ii
                weights = ud * area * RlenBar(ie) '要素の重量
                For kk = 1 To 3
                    If GravMulti(kk) <> 0 Then
                        weightk = weights * GravMulti(kk)
                        pny = weightk * CosYBar(ie, kk)
                        pnz = weightk * CosZBar(ie, kk)
                        ptload = weightk * CosXBar(ie, kk)

                        If pny <> 0 Then
                            '垂直荷重Ｐnyによる換算荷重の計算
                            forceb = 0.5 * pny
                            b1 = forceb * CosYBar(ie, 1)
                            b2 = forceb * CosYBar(ie, 2)
                            b3 = forceb * CosYBar(ie, 3)
                            For ii = 1 To 2
                                k = kbuf(ii)
                                Tf(k + 1) = Tf(k + 1) + b1
                                Tf(k + 2) = Tf(k + 2) + b2
                                Tf(k + 3) = Tf(k + 3) + b3
                            Next ii
                            BarYShear(ie, 1) = BarYShear(ie, 1) - forceb
                            BarYShear(ie, 2) = BarYShear(ie, 2) - forceb
                            If Ntype = 2 Then
                                rmomentb = forceb * RlenBar(ie) / 6
                                b1 = rmomentb * CosZBar(ie, 1)
                                b2 = rmomentb * CosZBar(ie, 2)
                                b3 = rmomentb * CosZBar(ie, 3)
                                For ii = 1 To 2
                                    k = kbuf(ii)
                                    If ii = 2 Then
                                        b1 = -b1
                                        b2 = -b2
                                        b3 = -b3
                                    End If
                                    Tf(k + 4) = Tf(k + 4) + b1
                                    Tf(k + 5) = Tf(k + 5) + b2
                                    Tf(k + 6) = Tf(k + 6) + b3
                                Next ii
                                BarZMoment(ie, 1) = BarZMoment(ie, 1) - rmomentb
                                BarZMoment(ie, 2) = BarZMoment(ie, 2) + rmomentb
                            End If
                        End If

                        If pnz <> 0 Then
                            '垂直荷重Ｐnzによる換算荷重の計算
                            forceb = 0.5 * pnz
                            b1 = forceb * CosZBar(ie, 1)
                            b2 = forceb * CosZBar(ie, 2)
                            b3 = forceb * CosZBar(ie, 3)
                            For ii = 1 To 2
                                k = kbuf(ii)
                                Tf(k + 1) = Tf(k + 1) + b1
                                Tf(k + 2) = Tf(k + 2) + b2
                                Tf(k + 3) = Tf(k + 3) + b3
                            Next ii
                            BarZShear(ie, 1) = BarZShear(ie, 1) - forceb
                            BarZShear(ie, 2) = BarZShear(ie, 2) - forceb
                            If Ntype = 2 Then
                                rmomentb = -forceb * RlenBar(ie) / 6
                                b1 = rmomentb * CosYBar(ie, 1)
                                b2 = rmomentb * CosYBar(ie, 2)
                                b3 = rmomentb * CosYBar(ie, 3)
                                For ii = 1 To 2
                                    k = kbuf(ii)
                                    If ii = 2 Then
                                        b1 = -b1
                                        b2 = -b2
                                        b3 = -b3
                                    End If
                                    Tf(k + 4) = Tf(k + 4) + b1
                                    Tf(k + 5) = Tf(k + 5) + b2
                                    Tf(k + 6) = Tf(k + 6) + b3
                                Next ii
                                BarYMoment(ie, 1) = BarYMoment(ie, 1) - rmomentb
                                BarYMoment(ie, 2) = BarYMoment(ie, 2) + rmomentb
                            End If
                        End If

                        If ptload <> 0 Then
                            '接線荷重Ｐtによる換算荷重の計算
                            forceb = 0.5 * ptload
                            b1 = forceb * CosXBar(ie, 1)
                            b2 = forceb * CosXBar(ie, 2)
                            b3 = forceb * CosXBar(ie, 3)
                            For ii = 1 To 2
                                k = kbuf(ii)
                                Tf(k + 1) = Tf(k + 1) + b1
                                Tf(k + 2) = Tf(k + 2) + b2
                                Tf(k + 3) = Tf(k + 3) + b3
                            Next ii
                            BarForce(ie, 1) = BarForce(ie, 1) + forceb
                            BarForce(ie, 2) = BarForce(ie, 2) - forceb
                        End If
                    End If
                Next kk
            End If
        Next ie

    End Sub

    Private Sub WeightLoad2()
        '自重荷重の加算（ﾄﾗｽ･ﾗｰﾒﾝ混合）
        '軸力等は初期内力として処理
        Dim ie, ii, k, kb, kk, kp, kx As Integer
        Dim cb As Single
        Dim area, b1, b2, b3, forceb, pny, pnz, ptload As Double
        Dim rmoment1, rmoment2, rmomentb As Double
        Dim ud, weightk, weights As Double
        Dim kbuf(2) As Integer
        Dim fbuf(2) As Double

        cb = 1.0 - Crate
        kb = 0
        For ie = 1 To Nelem
            kp = NumMat(ie)
            If kp <> kb Then
                kb = kp
                ud = DataMat(kp, 3)
                area = DataMat(kp, 4)
            End If
            If ud > 0 Then
                For ii = 1 To 2
                    kx = NNelem(ie, ii)
                    kbuf(ii) = Lr(kx) - 1
                Next ii
                weights = ud * area * RlenBar(ie) '要素の重量
                For kk = 1 To 3
                    If GravMulti(kk) <> 0 Then
                        weightk = weights * GravMulti(kk)
                        pny = weightk * CosYBar(ie, kk)
                        pnz = weightk * CosZBar(ie, kk)
                        ptload = weightk * CosXBar(ie, kk)
                        If pny <> 0 Then
                            '垂直荷重Ｐnyによる換算荷重の計算
                            Select Case KindElem(ie)
                                Case 3
                                    fbuf(1) = 3 * pny / 8
                                    fbuf(2) = 5 * pny / 8
                                    rmomentb = pny * RlenBar(ie) / 8
                                Case 4
                                    fbuf(1) = 5 * pny / 8
                                    fbuf(2) = 3 * pny / 8
                                    rmomentb = pny * RlenBar(ie) / 8
                                Case Else
                                    fbuf(1) = 0.5 * pny
                                    fbuf(2) = fbuf(1)
                                    rmomentb = pny * RlenBar(ie) / 12
                            End Select
                            If KindElem(ie) = 2 Then
                                rmoment1 = rmomentb
                                rmoment2 = rmomentb
                            ElseIf KindElem(ie) > 2 Then
                                b1 = Crate * 0.5 * pny
                                fbuf(1) = cb * fbuf(1) + b1
                                fbuf(2) = cb * fbuf(2) + b1
                                If KindElem(ie) = 3 Then
                                    rmoment1 = Crate * pny * RlenBar(ie) / 12
                                    rmoment2 = cb * rmomentb + rmoment1
                                Else
                                    rmoment2 = Crate * pny * RlenBar(ie) / 12
                                    rmoment1 = cb * rmomentb + rmoment2
                                End If
                            End If
                            For ii = 1 To 2
                                k = kbuf(ii)
                                Tf(k + 1) = Tf(k + 1) + fbuf(ii) * CosYBar(ie, 1)
                                Tf(k + 2) = Tf(k + 2) + fbuf(ii) * CosYBar(ie, 2)
                                Tf(k + 3) = Tf(k + 3) + fbuf(ii) * CosYBar(ie, 3)
                                If KindElem(ie) > 1 Then
                                    If ii = 1 Then
                                        Tf(k + 4) = Tf(k + 4) + rmoment1 * CosZBar(ie, 1)
                                        Tf(k + 5) = Tf(k + 5) + rmoment1 * CosZBar(ie, 2)
                                        Tf(k + 6) = Tf(k + 6) + rmoment1 * CosZBar(ie, 3)
                                    Else
                                        Tf(k + 4) = Tf(k + 4) - rmoment2 * CosZBar(ie, 1)
                                        Tf(k + 5) = Tf(k + 5) - rmoment2 * CosZBar(ie, 2)
                                        Tf(k + 6) = Tf(k + 6) - rmoment2 * CosZBar(ie, 3)
                                    End If
                                End If
                            Next ii
                            BarYShear(ie, 1) = BarYShear(ie, 1) - fbuf(1)
                            BarYShear(ie, 2) = BarYShear(ie, 2) - fbuf(2)
                            If KindElem(ie) > 1 Then
                                BarZMoment(ie, 1) = BarZMoment(ie, 1) - rmoment1
                                BarZMoment(ie, 2) = BarZMoment(ie, 2) + rmoment2
                            End If
                        End If

                        If pnz <> 0 Then
                            '垂直荷重Ｐnzによる換算荷重の計算
                            Select Case KindElem(ie)
                                Case 3
                                    fbuf(1) = 3 * pnz / 8
                                    fbuf(2) = 5 * pnz / 8
                                    rmomentb = -pnz * RlenBar(ie) / 8
                                Case 4
                                    fbuf(1) = 5 * pnz / 8
                                    fbuf(2) = 3 * pnz / 8
                                    rmomentb = -pnz * RlenBar(ie) / 8
                                Case Else
                                    fbuf(1) = 0.5 * pnz
                                    fbuf(2) = fbuf(1)
                                    rmomentb = -pnz * RlenBar(ie) / 12
                            End Select
                            If KindElem(ie) = 2 Then
                                rmoment1 = rmomentb
                                rmoment2 = rmomentb
                            ElseIf KindElem(ie) > 2 Then
                                b1 = Crate * 0.5 * pnz
                                fbuf(1) = cb * fbuf(1) + b1
                                fbuf(2) = cb * fbuf(2) + b1
                                If KindElem(ie) = 3 Then
                                    rmoment1 = -Crate * pnz * RlenBar(ie) / 12
                                    rmoment2 = cb * rmomentb + rmoment1
                                Else
                                    rmoment2 = -Crate * pnz * RlenBar(ie) / 12
                                    rmoment1 = cb * rmomentb + rmoment2
                                End If
                            End If
                            For ii = 1 To 2
                                k = kbuf(ii)
                                Tf(k + 1) = Tf(k + 1) + fbuf(ii) * CosZBar(ie, 1)
                                Tf(k + 2) = Tf(k + 2) + fbuf(ii) * CosZBar(ie, 2)
                                Tf(k + 3) = Tf(k + 3) + fbuf(ii) * CosZBar(ie, 3)
                                If KindElem(ie) > 1 Then
                                    If ii = 1 Then
                                        Tf(k + 4) = Tf(k + 4) + rmoment1 * CosYBar(ie, 1)
                                        Tf(k + 5) = Tf(k + 5) + rmoment1 * CosYBar(ie, 2)
                                        Tf(k + 6) = Tf(k + 6) + rmoment1 * CosYBar(ie, 3)
                                    Else
                                        Tf(k + 4) = Tf(k + 4) - rmoment2 * CosYBar(ie, 1)
                                        Tf(k + 5) = Tf(k + 5) - rmoment2 * CosYBar(ie, 2)
                                        Tf(k + 6) = Tf(k + 6) - rmoment2 * CosYBar(ie, 3)
                                    End If
                                End If
                            Next ii
                            BarZShear(ie, 1) = BarZShear(ie, 1) - fbuf(1)
                            BarZShear(ie, 2) = BarZShear(ie, 2) - fbuf(2)
                            If KindElem(ie) > 1 Then
                                BarYMoment(ie, 1) = BarYMoment(ie, 1) - rmoment1
                                BarYMoment(ie, 2) = BarYMoment(ie, 2) + rmoment2
                            End If
                        End If

                        If ptload <> 0 Then
                            '接線荷重Ｐtによる換算荷重の計算
                            forceb = 0.5 * ptload
                            b1 = forceb * CosXBar(ie, 1)
                            b2 = forceb * CosXBar(ie, 2)
                            b3 = forceb * CosXBar(ie, 3)
                            For ii = 1 To 2
                                k = kbuf(ii)
                                Tf(k + 1) = Tf(k + 1) + b1
                                Tf(k + 2) = Tf(k + 2) + b2
                                Tf(k + 3) = Tf(k + 3) + b3
                            Next ii
                            BarForce(ie, 1) = BarForce(ie, 1) + forceb
                            BarForce(ie, 2) = BarForce(ie, 2) - forceb
                        End If
                    End If
                Next kk
            End If
        Next ie

    End Sub

    Private Sub Bars3Cal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim ib, iconv, icount, id, ie, ii, ik, istage As Integer
        Dim j, k, mb, nb, nk As Integer
        Dim b1, drmesh, eps, fwx, rmesh, sec As Single
        Dim df, fmax, tf0, tf1, tfb, ub, ubb As Double
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        Crate = 0.001
        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        Call PnumImproveNew(mb, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定

        Call InitialSet2(mb)  '初期設定2

        Call ResFile2(mb)   '結果ﾌｧｲﾙへの出力2

        rmesh = 0
        drmesh = 0.8 / NKmax
        For ik = 1 To NKmax
            Call CosCalc()  '部材の方向余弦の計算
            Call LoadSet()  '荷重の設定
            If KindGrav > 0 Then
                If Ntype < 3 Then
                    Call WeightLoad()   '自重荷重の加算
                Else
                    Call WeightLoad2()   '自重荷重の加算
                End If
            End If

            aa$ = "要素計算中" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)

            Application.DoEvents()
            icount = 0
            istage = 0
            For ie = 1 To Nelem
                Call ElemMatrix(ie, istage)     '要素ﾏﾄﾘｯｸｽの計算
                Call Store()                                    '全体ﾏﾄﾘｯｸｽへの蓄積
                If icount < 99 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ie

            If Nspring > 0 Then
                Call SpringSet()    'バネ支持の設定
            End If

            '進行表示
            rmesh = rmesh + 0.2 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2

            If Nbound > 0 Then
                For ib = 1 To Nbound
                    If Ntype < 3 Then
                        'j = Ndim * (Nrest(ib) - 1)
                        j = Ndim * (Kcomp(Nrest(ib)) - 1)
                        If Ntype = 1 Then
                            nb = 3
                        Else
                            nb = 6
                        End If
                    Else
                        k = Nrest(ib)
                        j = Lr(k) - 1
                        nb = NvarP(Kcomp(k))
                    End If
                    For id = 1 To nb
                        If Jdirect(ib, id) > 0 Then
                            ub = Vdirect(ib, id)
                            k = j + id
                            Fdirect(ib, id) = Tf(k)
                            Call RestCond(k, mb, ub)    '拘束条件処理
                        End If
                    Next id
                Next ib
            End If

            Call Solver1()  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

            Call Solver2(mb)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

            Application.DoEvents()

            '進行表示
            rmesh = rmesh + 0.8 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2
            Dim timenew1 As Date = Now
            sec = TimeLap(Timst, timenew1)
            b1 = 1 - rmesh
            Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算

            If NKmax > 1 Then
                df = 0 : fmax = 0
                For j = 1 To Nall
                    ub = Math.Abs(Tf(j) - Tfx(j))
                    If ub > df Then
                        df = ub
                    End If
                    ubb = Math.Abs(Tfx(j))
                    If ubb > fmax Then
                        fmax = ubb
                    End If
                    If KindDPL = 1 Then
                        Tfx(j) = Tf(j)
                    Else
                        If ik = 1 Then
                            tfb = Tf(j)
                            tf1 = Tfx(j)
                            Call RelaxCalc2(tfb, tf1) '緩和計算
                        Else
                            tfb = Tf(j)
                            tf1 = Tfx(j)
                            tf0 = Tfxx(j)
                            Call RelaxCalc(tfb, tf1, tf0) '緩和計算
                        End If
                        Tfxx(j) = tf1
                        Tfx(j) = tfb
                    End If
                Next j
                If ik > 1 Then
                    If ik = NKmax Then
                        eps = df / fmax
                    End If
                    eps = df / fmax
                    If eps < EpsCalc Then
                        iconv = 1
                        nk = ik
                        Exit For
                    End If
                End If
                If ik = NKmax Then
                    nk = ik
                    Exit For
                Else
                    Call VCosCalc2()    '断面ＹB軸の方向余弦計算2
                    For ii = 1 To Nall
                        Tf(ii) = 0
                    Next ii
                    For ii = 1 To NumEff
                        Tk(ii) = 0
                    Next ii
                    For ii = 1 To Nelem
                        For j = 1 To 2
                            BarForce(ii, j) = 0
                            BarYShear(ii, j) = 0
                            BarZShear(ii, j) = 0
                            BarYMoment(ii, j) = 0
                            BarZMoment(ii, j) = 0
                        Next j
                    Next ii
                    For ib = 1 To Nbound
                        For j = 1 To 6
                            Fdirect(ib, j) = 0
                        Next j
                    Next ib
                End If
            Else
                iconv = 1
                Exit For
            End If
        Next ik

        Call ResFile3(iconv, nk, eps)   '結果ﾌｧｲﾙへの出力3

        Call ForceCalc()   '軸力等の計算

        Call ResFile4()     '結果ﾌｧｲﾙへの出力4

        Call ForceCalc2(mb) '全節点の力等計算

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        aa$ = "END   " & timn$
        SwK.WriteLine(aa$)

        If iconv > 0 Then
            Label1.Text = "計算終了！"
            Label2.Text = "計算結果をファイルへ出力しました。"
            Label3.Text = aa$
            aa$ = "計算が終了しました。"
            If KindDPL > 0 Then
                aa$ = aa$ + Cr$ + "繰返し計算回数" + Str$(nk)
            End If
            aa$ = aa$ + Cr$ + CalcRes$
        Else
            aa$ = "計算が収束しませんでした！"
            SwK.WriteLine(aa$)
            If KindDPL > 0 Then
                aa$ = aa$ + Cr$ + "繰返し計算回数" + Str$(nk)
            End If
            aa$ = aa$ + Cr$ + "計算結果をファイルへ出力しました。"
        End If
        SwK.Close()
        Me.BringToFront()
        MsgBox(aa$, 0, "計算確認")

        gr.Dispose()
        Me.Close()

    End Sub
End Class
